
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>深入分析ClassLoader工作机制 / 憋错料</title>

    <meta name="description" content="深入分析ClassLoader工作机制 ClassLoader 较为深入分析. from &lt;深入分析Java Web&gt; 加载CLASS到JVM中,审查每个类应该由谁加载,父优先的等级加载机制. 加载机制 ClassLoader类结构分析 ClassLoader抽象类,有很多子类,一般在实现自己的ClassLoader时候,一般都会继承URLClassLoader这个子类,因为这个类已经实现了大部分的工作,就像Servlet通过会直接HttpServlet一样. 打开源码: 几个重要的方法 protected final C ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">深入分析ClassLoader工作机制</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>ClassLoader 较为深入分析。</h1>
<p><em>from &lt;深入分析Java Web&gt;</em></p>
<hr>
<br /><strong>加载CLASS到JVM中，审查每个类应该由谁加载，父优先的等级加载机制。</strong></p>
<hr>
<h2>加载机制</h2>
<h3>ClassLoader类结构分析</h3>
<p>ClassLoader抽象类，有很多子类，一般在实现自己的ClassLoader时候，一般都会继承<strong>URLClassLoader</strong>这个子类，因为这个类已经实现了大部分的工作，就像Servlet通过会直接HttpServlet一样。</p>
<p>打开源码：</p>
<p>几个重要的方法</p>
<ul>
<li>protected final Class</li>
</ul>
<h3>等级加载机制</h3>
<hr>
<br />一层一层判断是否应该由本层ClassLoader加载，并通过在哪一层加载确定类的加载级别。</p>
<p><strong>Bootstrap ClassLoader</strong> :主要加载JVM自身工作需要的类，这个ClassLoader完全由JVM自己控制的。不准守普通的加载规则，没有父类和子类。</p>
<p><strong>sun.misc.Launcher</strong> java程序的入口就是sun.misc.Launcher,jdk的扩展类加载器ExtClassLoader和系统类加载器AppClassLoader都是Launcher的内部类。Launcher初始化extension classloader，system classloader，并将system classloader设置成为context classloader，但是仅仅返回system classloader给JVM。下列代码是Launcher构建的过程。</p>
<pre><code>public Launcher() {

        Launcher.ExtClassLoader var1;

        ...

            var1 = Launcher.ExtClassLoader.getExtClassLoader();

        ...

            this.loader = Launcher.AppClassLoader.getAppClassLoader(var1);

....

}
</code></pre>
<h4>类图:</h4>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaS5pbWd1ci5jb20vZ3pLbzcwcS5qcGc=.jpg"></p>
<p>　　可以看到APPClassLoader和ExtClassLoader都继承自URLClassLoader,在构建Launcher过程中，先创建ExtClassLoader，然后根据ExtClassLoader作为父加载器创建APPClassLoader。然后使用Launcher的getLauncher方法得到的就是APPClassLoader。如果在Java应用中没有其他的ClassLoader，则除了”java.ext.dirs”目录下的类由ExtClassLoader加载的外，其他的都是由APPClassLoader。看一下源码。</p>
<p>ExtClassLoader：</p>
<pre><code>    public static Launcher.ExtClassLoader getExtClassLoader() throws IOException {

            final File[] var0 = getExtDirs();//这里

            try {

                return (Launcher.ExtClassLoader)AccessController.doPrivileged(new PrivilegedExceptionAction() {

                    public Launcher.ExtClassLoader run() throws IOException {

                        int var1 = var0.length;

                        for(int var2 = 0; var2 &lt; var1; ++var2) {

                            MetaIndex.registerDirectory(var0[var2]);

                        }

                        return new Launcher.ExtClassLoader(var0);///这里

                    }

                });

            } catch (PrivilegedActionException var2) {

                throw (IOException)var2.getException();

            }

        }

     private static File[] getExtDirs() {

                String var0 = System.getProperty("java.ext.dirs");

    ...

    }</code></pre>
<p>APPClassLoader：使用ExtClassLoader作为父类加载器</p>
<pre><code> static class AppClassLoader extends URLClassLoader {

        public static ClassLoader getAppClassLoader(final ClassLoader var0) throws IOException {

            final String var1 = System.getProperty("java.class.path");//这里

            final File[] var2 = var1 == null?new File[0]:Launcher.getClassPath(var1);

            return (ClassLoader)AccessController.doPrivileged(new PrivilegedAction() {

                public Launcher.AppClassLoader run() {

                    URL[] var1x = var1 == null?new URL[0]:Launcher.pathToURLs(var2);

                    return new Launcher.AppClassLoader(var1x, var0);//这里

                }

            });

        }</code></pre>
<p>这是URLClassLoader的：</p>
<pre><code> public URLClassLoader(URL[] urls, ClassLoader parent,....){}
</code></pre>
<h4>加载Class文件到内存中的2种方式</h4>
<p>一种是隐式加载，一种是显式加载。</p>
<ol>
<li><strong>隐式加载</strong>： 就是不需要在代码中调用ClassLoader来加载的类，而是通过JVM来自动加载这些需要的类到内存中的方式，比如在我们继承或引用某些类的时候，JVM分析当前类引用的类不在内存中，那么就会自动加载类到内存中。</li>
<li><strong>显示加载</strong>：就是在代码中调用ClassLoader来加载一个类，比如<code>this.getClass().getClassLoader().loadClass()</code>或者<code>Class.forName()</code> 或者自定义的ClassLoader的loadClass方法。</li>
</ol>
<p>混合的方式，就是在自定义ClassLoader时候引用其他类，就算是隐式加载。</p>
<hr>
<h2>加载class的过程</h2>
<hr>
<br />加载过程，简单地看了一下代码。大概是：</p>
<p>—&gt;findClass(final String name)</p>
<p>—&gt; defineClass(String name, Resource res)</p>
<p>—&gt;Class</p>
<h3>加载字节码到内存中</h3>
<hr>
<br />在抽象类ClassLoader中，很多实现都交给子类实现，如如何找到，如何加载到内存中。就是findClass()方法。最常用的URLClassLoader的findClass源码如下；</p>
<pre><code> protected Class&lt;?&gt; findClass(final String name)

             throws ClassNotFoundException

        {

            try {

                return AccessController.doPrivileged(

                    new PrivilegedExceptionAction&lt;Class&gt;() {

                        public Class run() throws ClassNotFoundException {

                            String path = name.replace(‘.‘, ‘/‘).concat(".class");

                            Resource res = ucp.getResource(path, false);

                            if (res != null) {

                                try {

                                    return defineClass(name, res);

                                } catch (IOException e) {

                                    throw new ClassNotFoundException(name, e);

                                }

                            } else {

                                throw new ClassNotFoundException(name);

                            }

                        }

                    }, acc);

            } catch (java.security.PrivilegedActionException pae) {

                throw (ClassNotFoundException) pae.getException();

            }

        }</code></pre>
<p>简要说明一下：首先将Path，类名的包定义，由’.’换为路径的’/’。并将.class加上。然后<strong>ucp</strong>(URLClassPath类型)定义哪里找到这个class文件，读取它的字节流。然后通过defineClass来实例类class对象。根据URL传过来的是Jar包还是实际Class文件，就能创建不同的Loader了，这样就实现加载Class文件到内存中。下图还可以看出Loader是URLClassPath的内部类。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaS5pbWd1ci5jb20veE1TbmZZMC5qcGc=.jpg"></p>
<hr>
<h2>常见加载类错误分析</h2>
<hr>
<h3>ClassNotFoundException</h3>
<p>这个非常常见的错误，一般问题是找不到.class文件，就是classpath路径和你想要的class文件路径不在一个地方。如果不知道classpath路径是什么，可以通过下列代码方式找到。</p>
<pre><code>    this.getClass().getClassLoader().getResource("").toString();</code></pre>
<p>通常加载一个不知道的类时就会发生这样的错误。</p>
<pre><code> public class notFound{

        public static void main(String []args){

            try {

                Class.forName("NotFoundClass");

            }catch(ClassNotFoundException e){ 

                e.printStackTrace();

            }

        }

    }</code></pre>
<p>显示加载的几种方式：</p>
<ul>
<li>Class.forName();</li>
<li>ClassLoader的loadClass（）;</li>
<li>ClassLoader的findSystemClass（）;</li>
</ul>
<hr>
<hr>
<h3>UnsatisfiedLinkError</h3>
<p>这个问题不常见，出现的场景就是调用某些本地lib中的native方法时，没有找到这样的lib。报出的错误。</p>
<pre><code>/**

     * 文件描述：

     * 作者： bamboo

     * 时间： 2016/12/9

     */

    public class NoLibException {

        public native void nativeMethod();

        static {

            System.loadLibrary("NoLib");

        }

        public static void main(String[] args) {

            new NoLibException().nativeMethod();

        }

    }</code></pre>
<hr>
<pre><code>    java.lang.UnsatisfiedLinkError: no NoLib in java.library.path

    at java.lang.ClassLoader.loadLibrary(ClassLoader.java:1886)

    at java.lang.Runtime.loadLibrary0(Runtime.java:849)

    at java.lang.System.loadLibrary(System.java:1088)

    at CCF.NoLibException.&lt;clinit&gt;(NoLibException.java:11)</code></pre>
<hr>
<h3>ClassCastException</h3>
<hr>
<br />强制转换异常，比如说想把String强制转换为Integer</p>
<p>代码</p>
<pre><code>import java.util.HashMap;

    import java.util.Map;

    /**

     * 文件描述：

     * 作者： bamboo

     * 时间： 2016/12/9

     */

    public class CastException {

        public static Map m = new HashMap() {

            {

                put("a", "2");

            }

        };

        public static void main(String[] args) {

            Integer integer= (Integer) m.get("a");

            System.out.println(integer);

        }

    }</code></pre>
<p>结果：</p>
<pre><code>Exception in thread "main" java.lang.ClassCastException: java.lang.String cannot be cast to java.lang.Integer

        at CCF.CastException.main(CastException.java:19)

        at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)

        at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:57)

        at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)

        at java.lang.reflect.Method.invoke(Method.java:606)

        at com.intellij.rt.execution.application.AppMain.main(AppMain.java:144)</code></pre>
<hr>
<h2>实现自己的ClassLoader</h2>
<p>之前写的博客。</p>
<p><a href="http://blog.csdn.net/newpidian/article/details/52831121" rel="external nofollow noreferrer">http://blog.csdn.net/newpidian/article/details/52831121</a> 主要实现以下3个功能</p>
<ul>
<li>获取类加载器</li>
<li>根据类名称加载类</li>
<li>获取指定包下的所有类</li>
</ul>
<h3>加载自定义格式的Class文件</h3>
<p>实现一个从远端服务器，经过加密的class文件的网络传输，在本地解密，并通过defineClass方法创建这个类的实例的方法。</p>
<p>代码如下：</p>
<pre><code>import java.io.ByteArrayOutputStream;

    import java.io.File;

    import java.io.InputStream;

    import java.net.URL;

    /**

     * 文件描述：

     * 作者： bamboo

     * 时间： 2016/12/9

     */

    public class NetClassLoader extends ClassLoader {

        private String classPath;

        private String packageName;

        public NetClassLoader(ClassLoader parent, String classPath, String packageName) {

            super(parent);

            this.classPath = classPath;

            this.packageName = packageName;

        }

        public NetClassLoader(String classPath, String packageName) {

            this.classPath = classPath;

            this.packageName = packageName;

        }

        @Override

        protected Class&lt;?&gt; findClass(String name) throws ClassNotFoundException {

            Class&lt;?&gt; aClass = findLoadedClass(name);

            if (aClass != null) {

                return aClass;

            }

            if (packageName.startsWith(name)) {

                byte[] classData = getData(name);

                if (classData == null) {

                    throw new ClassNotFoundException();

                } else {

                    defineClass(name, classData, 0, classData.length);

                }

            }

            return super.loadClass(name);

        }

        private byte[] getData(String className) {

            String path = classPath + File.separator + className.replace(‘.‘, File.separatorChar) + ".class";

            try {

                URL url = new URL(path);

                InputStream is = url.openStream();

                ByteArrayOutputStream stream = new ByteArrayOutputStream();

                byte[] buffer = new byte[2048];

                int num = 0;

                while ((num = is.read(buffer)) != -1) {

                    stream.write(buffer, 0, num);

                }

                return stream.toByteArray();

            } catch (Exception e) {

                e.printStackTrace();

            }

            return null;

        }

        private byte[] deCode(byte[] src) {

            byte[] decode = null;

            ///字节编码处理

            return decode;

        }

    }

##实现类的热部署

在JVM加载类之前会先判定要请求的类是否已经被加载过来，就是通过findLoadedClass()来返回类实例，如果已经加载了，则loadClass()会冲突，如何判断是不是同一个类有2个条件。

- 类名是否完全一样，包括包名。

- 看这个类的ClassLoader是否完全一样。这里指的是是不是同一个ClassLoader实例。即使是同一个ClassLoader类的不同实例，加载的类也不一样。

所以实现热部署，可以创建不同的ClassLoader的实例对象，然后通过这个不同的实例对象来加载同名类。

</code></pre>
<pre><code>import java.io.ByteArrayOutputStream;

import java.io.File;

import java.io.FileInputStream;

import java.io.InputStream;

/**

 * 文件描述：

 * 作者： bamboo

 * 时间： 2016/12/9

 */

public class ClassReloader extends ClassLoader {

    private String classPath;

    public ClassReloader(ClassLoader parent, String classPath) {

        super(parent);

        this.classPath = classPath;

    }

    public ClassReloader(String classPath) {

        this.classPath = classPath;

    }

    @Override

    protected Class&lt;?&gt; findClass(String name) throws ClassNotFoundException {

        byte[] classData = getData(name);

        if (classData == null) {

            throw new ClassNotFoundException();

        } else {

            return defineClass(name, classData, 0, classData.length);

        }

    }

    private byte[] getData(String className) {

        String path = classPath +  className+".class";

        try {

            InputStream is = new FileInputStream(path);

            ByteArrayOutputStream stream = new ByteArrayOutputStream();

            byte[] buffer = new byte[2048];

            int num = 0;

            while ((num = is.read(buffer)) != -1) {

                stream.write(buffer, 0, num);

            }

            return stream.toByteArray();

        } catch (Exception e) {

            e.printStackTrace();

        }

        return null;

    }

    public static void main(String[] args) {

        try {

            String path = "C:\\Users\\bamboo\\Desktop\\单源\\Leetcode\\out\\";

            ClassReloader reloader = new ClassReloader(path);

            Class r = reloader.findClass("AllOne");

            System.out.println((r.newInstance()));

            ClassReloader reloader1 = new ClassReloader(path);

            Class r1 = reloader1.findClass("AllOne");

            System.out.println((r1.newInstance()));

        } catch (Exception e) {

            e.printStackTrace();

        }

    }

}
</code></pre>
<pre><code>

输出

    AllOne@26a30589

    [email&#160;protected]

如果将 `   Class r1 = reloader1.findClass("AllOne");`改为

                    Class r1 = reloader.findClass("AllOne");

则会抛出duplicate class definition，类的重复定义。

</code></pre>
<pre><code>[email&#160;protected]

Exception in thread "main" java.lang.LinkageError: loader (instance of  ParallelBasic/ClassReloader): attempted  duplicate class definition for name: "AllOne"

    at java.lang.ClassLoader.defineClass1(Native Method)

    at java.lang.ClassLoader.defineClass(ClassLoader.java:800)

    at java.lang.ClassLoader.defineClass(ClassLoader.java:643)

    at ParallelBasic.ClassReloader.findClass(ClassReloader.java:32)

    at ParallelBasic.ClassReloader.main(ClassReloader.java:61)

    at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)

    at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:57)

    at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)

    at java.lang.reflect.Method.invoke(Method.java:606)

    at com.intellij.rt.execution.application.AppMain.main(AppMain.java:144)
</code></pre>
<p>“`</p>
<p><strong>一个问题：</strong>如果使用不同的ClassLoader实例加载同一个类会怎么样，会不会导致JVM的PermGen（永久代）n区无限增大？？答案是否定的，why，因为ClassLoader对象也是对象，在没有被持有引用的时候，也会被JVM回收。值得注意的是，被ClassLoader加载的类的字节码会一直保存在JVM的PermGen中，这个数据一般是在Full GC的时候才会被回收，所以，如果应用大量使用动态类加载。Full GC又不是太频繁，也要注意PermGen的大小，防止内存溢出。</p>
<hr>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-25 02:15:15 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/ash/" title="ash">ash</a>, <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/output/" title="output">output</a>, <a href="https://www.biecuoliao.com/tag/%e7%88%b6%e7%b1%bb/" title="父类">父类</a>, <a href="https://www.biecuoliao.com/tag/lib/" title="lib">lib</a>, <a href="https://www.biecuoliao.com/tag/adc/" title="adc">adc</a>, <a href="https://www.biecuoliao.com/tag/%e5%ad%97%e8%8a%82%e6%b5%81/" title="字节流">字节流</a>, <a href="https://www.biecuoliao.com/tag/java-net/" title="java&period;net">java&period;net</a>, <a href="https://www.biecuoliao.com/tag/%e5%8a%a8%e6%80%81%e7%b1%bb%e5%8a%a0%e8%bd%bd/" title="动态类加载">动态类加载</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>深入分析ClassLoader工作机制的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgNoaN4.html" rel="bookmark">详细深入分析 ClassLoader 工作机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				申明:本文首发于 详细深入分析 Java ClassLoader 工作机制 ,如有转载,注明原出处即可,谢谢配合. 详细深入分析 Java ClassLoader 工作机制 什么是 ClassLoader ClassLoader 作用 1ClassLoader 类结构分析 2ClassLoader 的等级加载机制 Java默认提供的三个ClassLoader ClassLoader加载类的原理 原理介绍 2为什么要使用双亲委托这种模型呢 3 但是JVM在搜索类的时候又是如何判定两个class是相			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0l112N3.html" rel="bookmark">第六章 深入分析ClassLoader工作机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				classLoader是类加载器,负责将Class加载到JVM中,还有一个作用是审查每个类由谁加载,它是一种父优先的等级加载机制. 还有一个任务是,将class字节码重新解析成JVM统一要求的对象格式. 6.1 ClassLoader类结构分析 6.2 ClassLoader的等级加载机制 6.3 如何加载class文件 6.3.1 加载字节码到内存 6.3.2 验证与解析 6.3.3 初始化class对象 6.4 常见加载类错误分析   6.4.1 ClassNotFoundException			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6G2jN0.html" rel="bookmark">深入理解ClassLoader工作机制（jdk1&period;8）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ClassLoader 顾名思义就是类加载器,ClassLoader 作用: 负责将 Class 加载到 JVM 中    审查每个类由谁加载(父优先的等级加载机制)    将 Class 字节码重新解析成 JVM 统一要求的对象格式 类加载时机与过程 类从被加载到虚拟机内存中开始,直到卸载出内存为止,它的整个生命周期包括了:加载.验证.准备.解析.初始化.使用和卸载这7个阶段.其中,验证.准备和解析这三个部分统称为连接(linking).这里写图片描述 其中,加载.验证.准备.初始化和卸载这五			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/ME6jvy0.html" rel="bookmark">ClassLoader工作机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本人在研究生阶段做JavaWeb开发时,当把项目发布到Tomcat上运行时,曾遇到过一个神奇的问题,这个问题由&quot;CLassCastException&quot;异常引起,当然这个异常很常见,其实我要说的神奇之处在于------我明明使用的是这个类本身new的对象,然后编译没有问题,但运行时却抛出这个异常.类似这样:MyClass mc=new MyClass(),异常就发生在这一句,是不是很奇怪了.为什么会类型转换失败? 一般来说,产生ClassCastException的主要原因有以下两点: 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OdXXr4.html" rel="bookmark">ClassLoader 工作机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ClassLoader 采用上级委托接待机制加载 class JVM 平台提供三层 ClassLoader 1.Bootstrap ClassLoader:主要加载 JVM 自身工作需要的类 2.ExtClassLoader:加载 VIP 类 3.AppClassLoader:加载自定义类			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEokbD3.html" rel="bookmark">深入分析 Java I&sol;O 的工作机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				I/O 问题可以说是当今互联网 Web 应用中所面临的主要问题之一,因为当前在这个海量数据时代,数据在网络中随处流动.这个流动的过程中都涉及到 I/O 问题,可以说大部分 Web 应用系统的瓶颈都是 I/O 瓶颈.本文的目的正是分析 I/O 的内在工作机制,你将了解到:Java 的 I/O 类库的基本架构:磁盘 I/O 工作机制:网络 I/O 的工作机制:其中以网络 I/O 为重点介绍 Java Socket 的工作方式:你还将了解到 NIO 的工作方式,还有同步和异步以及阻塞与非阻塞的区别,最			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xRWw74.html" rel="bookmark">深入分析 Java I&sol;O 的工作机制（转载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				声明:本文转自 http://www.ibm.com/developerworks/cn/java/j-lo-javaio/ I/O 问题可以说是当今互联网 Web 应用中所面临的主要问题之一,因为当前在这个海量数据时代,数据在网络中随处流动.这个流动的过程中都涉及到 I/O 问题,可以说大部分 Web 应用系统的瓶颈都是 I/O 瓶颈.本文的目的正是分析 I/O 的内在工作机制,你将了解到:Java 的 I/O 类库的基本架构:磁盘 I/O 工作机制:网络 I/O 的工作机制:其中以网络 I/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLLeYEM.html" rel="bookmark">java虚拟机学习-慢慢琢磨JVM&lpar;2-1&rpar;ClassLoader的工作机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ClassLoader的工作机制 java应用环境中不同的class分别由不同的ClassLoader负责加载. 一个jvm中默认的classloader有Bootstrap ClassLoader.Extension ClassLoader.App ClassLoader,分别各司其职: Bootstrap ClassLoader     负责加载java基础类,主要是 %JRE_HOME/lib/ 目录下的rt.jar.resources.jar.charsets.jar和class等 Ex			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RqD6qM.html" rel="bookmark">深入分析 Java I&sol;O 的工作机制--转载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java 的 I/O 类库的基本架构 I/O 问题是任何编程语言都无法回避的问题,可以说 I/O 问题是整个人机交互的核心问题,因为 I/O 是机器获取和交换信息的主要渠道.在当今这个数据大爆炸时代,I/O 问题尤其突出,很容易成为一个性能瓶颈.正因如此,所以 Java 在 I/O 上也一直在做持续的优化,如从 1.4 开始引入了 NIO,提升了 I/O 的性能.关于 NIO 我们将在后面详细介绍. Java 的 I/O 操作类在包 java.io 下,大概有将近 80 个类,但是这些类大概可以			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r4J22b4.html" rel="bookmark" class="title">Android中实现消息推送（JPush）</a>
					<div>
						1,去JPush官网注册一个账号,创建你的app的应用,并且拿到你应用的AppKey 2,在JPush官网下载对应的sdk,解压出来,将libs文件下的所有的文件全部复制到你工程的libs文件中 3, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQbGb3.html" rel="bookmark" class="title">Foundation框架&mdash;集合</a>
					<div>
						一.NSArray和NSMutableArray (一)NSArray不可变数组 (1)NSArray的基本介绍 NSArray是OC中使用的数组,是面向对象的,以面向对象的形式操纵对象,是不可变数组 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vEbG90.html" rel="bookmark" class="title">java jdk和android sdk的安装以及环境变量的配置</a>
					<div>
						安卓环境变量设置 (烦)http://wenku.baidu.com/link?url=QRwpFhP8d0yJorhcvuZPrz3lNFQW-uwYg6TlZtv6uen6_SVsvRrzf0UJ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVgLZk0.html" rel="bookmark" class="title">Linux下 多线程编程</a>
					<div>
						ret = pthread_create(&amp;id,NULL,(void*)readThread,NULL); if(ret!=0) { printf(&quot;creat pthread i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Adn6b3.html" rel="bookmark" class="title">Hibernate批量处理海量数据的方法</a>
					<div>
						本文实例讲述了Hibernate批量处理海量数据的方法.分享给大家供大家参考,具体如下: Hibernate批量处理海量其实从性能上考虑,它是很不可取的,浪费了很大的内存.从它的机制上讲,Hibern ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bYvbmM.html" rel="bookmark" class="title">那些年，我们青涩单纯的暗恋</a>
					<div>
						我们每个人大都经历过暗恋,默默的喜欢一个人,却因为某种原因而不得不把这种感情放在心里,放在别人看不到的角落里.我曾经暗恋过一个男生五年,这份喜欢开始的很简单,也结束的很干脆.我们也许是因为对方的善解人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38LoBn3.html" rel="bookmark" class="title">MySQL插入、更新、删除数据</a>
					<div>
						1.插入数据:由于下表的id会自增,故赋值null. 注意:字符串用'   '单引号,不能双引号,英文状态下. 可以写上部分属性名进行插入操作,如bookTypeId没写,默认NULL. 也可以写上所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x5WL73.html" rel="bookmark" class="title">Windows 网络问题</a>
					<div>
						一.问题描述 每次重启后电脑的ip地址或无故没掉,或不能正常连网,要重新设置ip才能上网. 二.解决方法 netsh winsock reset 三.原理介绍 netsh winsock reset命 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KqYRY4.html" rel="bookmark" class="title">HDU1114 Piggy-Bank（完全背包）</a>
					<div>
						题意:给一个储钱罐,已知空的储钱罐和装了硬币的储钱罐的质量.然后给了n种硬币的质量和价值. 问储钱罐里最少有多少钱. 解法:完全背包.注意要初始化为 INF,要正好装满,如果结果是INF,输出This ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e5gDp0.html" rel="bookmark" class="title">&lbrack;控件&rsqb; 心形加载的view</a>
					<div>
						心形加载的view 效果: 素材图片: 源码: StarView.h 与 StarView.m // // StarView.h // Star // // Created by XianMingYo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d9ARn3.html" rel="bookmark" class="title">电商系统总结</a>
					<div>
						设置颜色,平铺图片 [UIColor colorWithPatternImage:[UIImage imageNamed:@&quot;bg_actionSheet_panel.png&quot;]] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEvOdD0.html" rel="bookmark" class="title">PHP使用RabbitMQ</a>
					<div>
						基本概念 Broker:简单来说就是消息队列服务器实体. Exchange:消息交换机,它指定消息按什么规则,路由到哪个队列. Queue:消息队列载体,每个消息都会被投入到一个或多个队列. Bind ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eyWRJ0.html" rel="bookmark" class="title">DOJ1187 ： 重建家园 （分数规划 &amp;amp&semi;&amp;amp&semi; 二分 &amp;amp&semi;&amp;amp&semi; kruskal）</a>
					<div>
						最优答案一定是一颗树 那么二分比值,不断kruskal找到最大可以满足的解就可以了 代码如下 #include &lt;cstdio&gt; #include &lt;algorithm&gt; us ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Zrozd3.html" rel="bookmark" class="title">python篇1&period;12&period;2---继承，多态与多态性，封装</a>
					<div>
						1.什么是继承 继承是一种创建 新的类的 方式. 在python中,新的类可继承自一个或多个父类,原始的类称为 基类或超类,新建的类 称为 派生类或子类. class ParentClass1: #定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVVLDyM.html" rel="bookmark" class="title">CPU工作状态的知识介绍</a>
					<div>
						转自:http://www.bbwxbbs.com/forum.php?mod=viewthread&amp;tid=2552 近几年,个人计算机的运行速度有了质的飞跃,但是功耗却没能与时俱进,着实让 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kpB9p3.html" rel="bookmark" class="title">sublime笔记</a>
					<div>
						Ctrl+Enter 下方加一行 (Ctrl+Shift+Enter) Ctrl+↑/↓ 滚动条 Ctrl+Shift+↑/↓ 移动当前行 ctrl+shift+←/→选择词 Ctrl+D 选择多个词 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k9OP74.html" rel="bookmark" class="title">16080401&lpar;面向摄像机的Instance模型&rpar;</a>
					<div>
						[目标] 面向摄像机的模型 [思路] 1 UE2中制作的 地形编辑器里面Decorations页面右键点击某一层,use billboard 2 在 ATerrainInfo::RenderDecor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nR5dp0.html" rel="bookmark" class="title">&lbrack;记录&rsqb;&lbrack;python&rsqb;python爬虫，下载某图片网站的所有图集</a>
					<div>
						随笔仅用于学习交流,转载时请注明出处,http://www.cnblogs.com/CaDevil/p/5958770.html 该随笔是记录我的第一个python程序,一个爬去指定图片站点的所有图集 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGAQBG3.html" rel="bookmark" class="title">Objective-C中的SEL &lpar;转载&rpar;</a>
					<div>
						 SEL 在Objective-C中,SEL是选择器(selector)的一个类型.选择器就是指向方法的一个指针,读者可以简单理解为程序运行到这里就会执行指定的方法,可以这样定义一个选择器: SEL  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KPN2O3.html" rel="bookmark" class="title">oracle中的日期函数的使用</a>
					<div>
						TO_DATE格式(以时间:2007-11-02   13:45:25为例) Year:               yy two digits 两位年                显示值:07   ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
